//+------------------------------------------------------------------+
//|                                                     _PattCor.mq4 |
//|     Copyright  2007, Vladimir Gomonov, Corellation with Pattern |
//|                                            metadriver@rambler.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, Vladimir Gomonov"
#property link      "metadriver@rambler.ru"

#property indicator_separate_window
#property indicator_buffers 1

#property indicator_color1 Chocolate
#property indicator_width1 2
#property indicator_color2 DarkGreen
#property indicator_width2 1
//#property indicator_color3 Crimson
//#property indicator_width3 1


extern int PreCorPeriod = 25;
extern int PostCorPeriod = 12;
//extern double PostPipsPerBar = 2;
extern int CorWindow = 1500;
//extern int Acceleration = 1;
extern int MA_Method = MODE_LWMA;
extern int MA_Period = 5;
extern int Ind_Period = 14;
extern int Ind_dt = 1;
//---- buffers
double CorBuf[];
double IndBuf[];
double MABuf[];

int init()
{
   IndicatorBuffers(3); 
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,CorBuf);
//   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,IndBuf);
   SetIndexBuffer(2,MABuf);
   return(0);
}


double Ind(int Shift)
{
//  return(iRSI(Symbol(),0,Ind_Period,PRICE_CLOSE,Shift));
  return(iStochastic(
         Symbol(),0,Ind_Period,Ind_Period,3,MODE_SMA,0,MODE_MAIN,Shift));
}

int start()
{
   int counted_bars=IndicatorCounted();
//---- check for possible errors
   if(counted_bars<0) return(-1);
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   int limit=Bars-counted_bars;
//     
//   int Win = IntMin(Bars-Limit, CorWindow);      
//---- main loop
   for(int i=limit-1; i>=0; i--)
     {
//      
     IndBuf[i] = Ind(i);
     MABuf[i] = iMA(Symbol(),0,MA_Period,0,MA_Method, PRICE_CLOSE,i);
     }

//   for(i=limit-1; i>=0; i--)
   for(i=1000; i>=0; i--)
     {
     if (true)// (i<Bars-(PreCorPeriod+PostCorPeriod+CorWindow))
       {
       double pIndi[100];
//   
       for (int k=0; k<PreCorPeriod-1; k++)
         pIndi[k]= IndBuf[i+Ind_dt*k] - IndBuf[i+Ind_dt*k+Ind_dt];
       
       double sdMulCor = 0;
//      
       for (int j=PostCorPeriod; j<CorWindow+PostCorPeriod; j++)
         {
//     
         double dMAij = MABuf[i+j-PostCorPeriod] - MABuf[i+j];
         double cdIndij; 
         double scdIndij=0; 
//    :
//       pIndi[] -     i 
//
//
         double ssdp = 0;    //   dp
         double ssdInd = 0;  //   c
         double ssdpCor = 0; //   dp*dIndijk
         for (k=0; k<PreCorPeriod-1; k++)
           {         
           double dp = pIndi[k];
           double dIndijk = (IndBuf[i+j+Ind_dt*k] - IndBuf[i+j+Ind_dt*k+Ind_dt]);
           
           ssdpCor += dp * dIndijk;
           ssdp += dp * dp;
           ssdInd += dIndijk * dIndijk;
           }
         if (ssdp*ssdInd>0)
              cdIndij = ssdpCor / MathSqrt(ssdp*ssdInd);
         else cdIndij = 0; 
//          scdIndij +=
//                 
         sdMulCor +=  cdIndij * dMAij;  // ???

         } // for (int j=PostCorPeriod; j<CorWindow+PostCorPeriod; j++)
       CorBuf[i] = sdMulCor; 
       } // if (i>Bars-(PreCorPeriod+PostCorPeriod))   
     }  // for(int i=limit-1; i>=0; i--)
} // start



